include:
  - project: ${CI_PROJECT_ROOT_NAMESPACE}/ci-cd
    ref: main
    file:
      - rust/projects/services.yml

variables:
  CONFIG_REPO: $PROJECT_PATH/services/rust/passport/config.git
  CONTAINER_VARIABLES_JSON: "{
      \"DB_PASSPORT_ACCESS_KEY\":\"$DB_PASSPORT_ACCESS_KEY\",
      \"DB_PASSPORT_CS\":\"$DB_PASSPORT_CS\",
      \"DB_PASSPORT_SECRET_KEY\":\"$DB_PASSPORT_SECRET_KEY\",

      \"DB_REGION_TITLE\":\"$DB_REGION_TITLE\",

      \"QUEUE_PASSPORT_LOGIN_ACCESS_KEY\":\"$QUEUE_PASSPORT_LOGIN_ACCESS_KEY\",
      \"QUEUE_PASSPORT_LOGIN_SECRET_KEY\":\"$QUEUE_PASSPORT_LOGIN_SECRET_KEY\",
      \"QUEUE_PASSPORT_LOGIN_PATH\":\"$QUEUE_PASSPORT_LOGIN_PATH\",
      \"QUEUE_ENDPOINT_URL\":\"$QUEUE_ENDPOINT_URL\",
      \"QUEUE_REGION_TITLE\":\"$QUEUE_REGION_TITLE\",

      \"JWT_PRIVATE_KEY\":\"$JWT_PRIVATE_KEY\",
      \"JWT_PUBLIC_KEY\":\"$JWT_PUBLIC_KEY\"
  }"

vendors:
  extends:
    - .vendors
  before_script:
    - !reference [.vendors, before_script]

    - |
      if [ -d $LIBS_PATH ]; then
        echo $CACHED_LIBS_EXISTS_MSG
      else
        apk add git

        echo $CLONING_LIBS_MSG

        git clone --depth 5 $PROJECT_PATH/$AUTH_LIB_REPO $LIBS_PATH/$AUTH_NAME
        git clone --depth 5 $PROJECT_PATH/$JWT_LIB_REPO $LIBS_PATH/$JWT_NAME
        git clone --depth 5 $PROJECT_PATH/$DB_LIB_REPO $LIBS_PATH/$DB_NAME
        git clone --depth 5 $PROJECT_PATH/$QUEUE_LIB_REPO $LIBS_PATH/$QUEUE_NAME
        git clone --depth 5 $PROJECT_PATH/$TRAITS_LIB_REPO $LIBS_PATH/$TRAITS_NAME
        git clone --depth 5 $PROJECT_PATH/$TYPES_LIB_REPO $LIBS_PATH/$TYPES_NAME
      
        git clone --depth 5 $PROJECT_PATH/$DB_MACRO_LIB_REPO $LIBS_PATH/macro/$DB_MACRO_NAME

        echo $CLONING_LIBS_DONE_MSG
      fi
  cache:
    !reference [.cache_vendors_common_services_pull_push_key]

tests:
  extends:
    - .tests
  before_script:
    - !reference [.tests, before_script]

    - |
      if [ ! -d "target" ]; then
        apk add openssl-dev
      fi

  cache:
    !reference [.cache_common_services_pull_push_key]

release:
  extends:
    - .release
  before_script:
    - !reference [.release, before_script]
    - apk add openssl-dev